package com.zhongzheng.modules.bank.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.bank.bo.QuestionBankChapterAddBo;
import com.zhongzheng.modules.bank.bo.QuestionBankChapterEditBo;
import com.zhongzheng.modules.bank.bo.QuestionBankChapterQueryBo;
import com.zhongzheng.modules.bank.domain.QuestionBankChapter;
import com.zhongzheng.modules.bank.mapper.QuestionBankChapterMapper;
import com.zhongzheng.modules.bank.service.IQuestionBankChapterService;
import com.zhongzheng.modules.bank.vo.QuestionBankChapterVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 题库大章Service业务层处理
 *
 * @author hjl
 * @date 2021-05-20
 */
@Service
public class QuestionBankChapterServiceImpl extends ServiceImpl<QuestionBankChapterMapper, QuestionBankChapter> implements IQuestionBankChapterService {

    @Override
    public QuestionBankChapterVo queryById(Long bankChapterId){
        QuestionBankChapter db = this.baseMapper.selectById(bankChapterId);
        return BeanUtil.toBean(db, QuestionBankChapterVo.class);
    }

    @Override
    public List<QuestionBankChapterVo> queryList(QuestionBankChapterQueryBo bo) {
        LambdaQueryWrapper<QuestionBankChapter> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getBankId() != null, QuestionBankChapter::getBankId, bo.getBankId());
        lqw.like(StrUtil.isNotBlank(bo.getName()), QuestionBankChapter::getName, bo.getName());
        lqw.eq(bo.getSort() != null, QuestionBankChapter::getSort, bo.getSort());
        lqw.in(bo.getStatus() != null, QuestionBankChapter::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<QuestionBankChapterVo> entity2Vo(Collection<QuestionBankChapter> collection) {
        List<QuestionBankChapterVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, QuestionBankChapterVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<QuestionBankChapter> page = (Page<QuestionBankChapter>)collection;
            Page<QuestionBankChapterVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(QuestionBankChapterAddBo bo) {
        QuestionBankChapter add = BeanUtil.toBean(bo, QuestionBankChapter.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(QuestionBankChapterEditBo bo) {
        QuestionBankChapter update = BeanUtil.toBean(bo, QuestionBankChapter.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(QuestionBankChapter entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
